package com.inca.npbusi.saset.bms_sa_set;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.auth.Userruninfo;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CTable;
import com.inca.np.gui.control.CToolbar;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.util.DecimalHelper;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.mpcsprodHelper;
import com.inca.pubsrv.hov.bms_sa_inv_info_hov.Bms_sa_inv_info_hov;
import java.awt.BorderLayout;
import java.math.BigDecimal;
import javax.swing.JPanel;

public class Bms_sa_set_master extends CMasterModel {
   public Bms_sa_set_master(CFrame var1, CMdeModel var2) {
      super(var1, "销售结算单", var2);
   }

   public String getTablename() {
      return "bms_sa_settle_doc_v";
   }

   public String getSaveCommandString() {
      return null;
   }

   protected JPanel createSecondtoolbar() {
      JPanel var1 = new JPanel();
      CToolbar var2 = new CToolbar();
      var1.setLayout(new BorderLayout());
      var1.add(var2);
      var1 = NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(var1, "由销售发货单生成(G)", "由销售发货单生成", "由销售发货单生成", 71, this.mdemodel), "确定(C)", "确定", "确定", 67, this.mdemodel), "回退确定(B)", "回退确定", "回退确定", 66, this.mdemodel), "作废(I)", "作废", "作废", 73, this.mdemodel), "生成发票(V)", "生成发票", "生成发票", 86, this.mdemodel), "导出金穗(O)", "导出金穗", "导出金穗", 79, this.mdemodel), "清除导出标志(R)", "清除导出标志", "清除导出标志", 82, this.mdemodel), "切换独立单元(A)", "切换独立单元", "切换独立单元", 65, this.mdemodel), "发票模板导出(Q)", "发票模板导出", "发票模板导出", 81, this.mdemodel), "发票细单导入(V)", "发票细单导入", "发票细单导入", 86, this.mdemodel);
      mpcsprodHelper.getSysProdConfig(ClientUserManager.getCurrentUser().getEntryid(), "prod202003").equals("1");
      return var1;
   }

   protected int on_beforeNew() {
      String var1;
      if ((var1 = ((Bms_sa_set_mde)this.mdemodel).getEntryid()) != null && !var1.equals("")) {
         return super.on_beforeNew();
      } else {
         this.infoMessage("提示", "您当前登录的角色没有指定独立单元，不能录入销售结算单！");
         return -1;
      }
   }

   protected int on_new(int var1) {
      Userruninfo var2 = ClientUserManager.getCurrentUser();
      this.setItemValue(var1, "inputmanid", var2.getUserid());
      this.setItemValue(var1, "inputmanname", var2.getUsername());
      this.setItemValue(var1, "entryid", ((Bms_sa_set_mde)this.mdemodel).getEntryid());
      this.setItemValue(var1, "entryname", ((Bms_sa_set_mde)this.mdemodel).getEntryname());
      this.setItemValue(var1, "sa_mode", "2");
      this.setItemValue(var1, "usestatus", "2");
      this.setItemValue(var1, "initflag", "0");
      this.setItemValue(var1, "printflag", "0");
      this.setItemValue(var1, "settype", "1");
      this.setItemValue(var1, "credate", NpbusiDBHelper.getSysdate());
      this.setItemValue(var1, "assessdate", NpbusiDBHelper.getSysdate());
      return super.on_new(var1);
   }

   protected int on_checkrow(int var1, DBTableModel var2) {
      for(int var3 = 0; var3 < this.mdemodel.getDetailModel().getRowCount(); ++var3) {
         if (this.mdemodel.getDetailModel().getdbStatus(var3) != 0 && this.mdemodel.getDetailModel().getdbStatus(var3) != 1 && this.mdemodel.getDetailModel().getdbStatus(var3) != 2) {
            this.mdemodel.getDetailModel().getdbStatus(var3);
         }
      }

      return super.on_checkrow(var1, var2);
   }

   protected String getOtherWheres() {
      String var1;
      if ((var1 = ((Bms_sa_set_mde)this.mdemodel).getEntryid()) != null && var1.length() != 0) {
         var1 = "entryid = " + var1 + " and initflag = 0 and settype = 1";
         return var1 + super.getOtherWheres();
      } else {
         this.infoMessage("提示", "您当前登录的角色没有指定独立单元，不能操作！");
         return null;
      }
   }

   protected void on_itemvaluechange(int var1, String var2, String var3) {
      if ("customid".equals(var2)) {
         RemotesqlHelper var4 = new RemotesqlHelper();
         DBTableModel var5 = null;
         String var6 = "select infoid from bms_sa_inv_info  where companyfunction = 2 and companyid = " + var3;

         try {
            var5 = var4.doSelect(var6, 0, 2);
         } catch (Exception var8) {
            var8.printStackTrace();
         }

         int var12;
         if ((var12 = var5.getRowCount()) == 1) {
            this.setItemValue(var1, "infoid", var5.getItemValue(0, "infoid"));
         } else if (var12 > 1) {
            (new Bms_sa_inv_info_hov()).showDialog(this.frame, "选择客户发票信息");
         }

         String var11 = ((Bms_sa_set_mde)this.mdemodel).getEntryid();
         var6 = "select settletypeid from pub_company_to_definfo where companyid=" + var3 + " and (entryid is null or entryid=" + var11 + ") order by nvl(entryid,-1) desc";

         String var10;
         try {
            DBTableModel var9;
            if ((var9 = var4.doSelect(var6, 0, 1)) != null && var9.getRowCount() > 0) {
               var10 = var9.getItemValue(0, "settletypeid");
               this.setItemValue(var1, "settletypeid", var10);
            }
         } catch (Exception var7) {
            var7.printStackTrace();
         }

         if ((var10 = this.getItemValue(var1, "agentid")) != null && !var10.equals("")) {
            this.setItemValue(var1, "agentid", "");
            this.setItemValue(var1, "agentopcode", "");
            this.setItemValue(var1, "agentname", "");
         }
      }

      super.on_itemvaluechange(var1, var2, var3);
   }

   protected void gensasettle(CTable var1) {
      int var2 = this.getRow();
      int var3 = 0;
      DBTableModel var4 = (DBTableModel)var1.getModel();
      int var7 = var1.getRowCount() - 1;

      for(int var5 = 0; var5 < var7; ++var5) {
         String var6;
         if ((var6 = var4.getItemValue(var5, "thistickqty")) != null && var6.length() > 0 && DecimalHelper.toDec(var6).compareTo(new BigDecimal("0")) != 0 && (var6 = var4.getItemValue(var5, "thistickqty")) != null && !var6.equals("") && !var6.equals("0")) {
            var3 = var5;
            break;
         }
      }

      this.setItemValue(var2, "fmid", var4.getItemValue(var3, "fmid"));
      this.setItemValue(var2, "fmopcode", var4.getItemValue(var3, "fmopcode"));
      this.setItemValue(var2, "fmname", var4.getItemValue(var3, "fmname"));
      this.setItemValue(var2, "exchange", var4.getItemValue(var3, "exchange"));
      this.tableChanged();
   }

   public String getHovOtherWheres(int var1, String var2) {
      String var3 = ((Bms_sa_set_mde)this.mdemodel).getEntryid();
      String var4;
      if ("infoid".equals(var2)) {
         var4 = this.getItemValue(var1, "customid");
         return " companyid = " + var4 + " and companyfunction = 2 ";
      } else if (var2.equals("agentopcode")) {
         if (!(var4 = this.getItemValue(var1, "customid")).equals("") && var4 != null) {
            return " type=2 and companyid=" + var4 + " and (entryid is null or entryid=" + var3 + ")";
         } else {
            this.infoMessage("提示！", "请选择客户！");
            return " 1>2";
         }
      } else {
         return var2.equals("agentid") ? " type=2 and (entryid is null or entryid=" + var3 + ")" : super.getHovOtherWheres(var1, var2);
      }
   }

   protected String getEditablecolumns(int var1) {
      int var2 = this.mdemodel.getDetailModel().getDBtableModel().getRowCount();
      String var3 = this.getItemValue(var1, "usestatus");
      return var2 > 0 && "2".equals(var3) ? "credate,sa_mode,settletypeid,invtype,assessdate,memo,infoid" : "";
   }

   protected int on_beforemodify(int var1) {
      this.setFocus("customopcode");
      return super.on_beforemodify(var1);
   }

   public void on_doubleclick(int var1, int var2) {
      this.setFocus("customopcode");
      super.on_doubleclick(var1, var2);
   }
}
